/******************************************************************************
 * {]p̡GFjt@²EF@2004/02
 *
 * nĥ GPL vAҦ{XҥiۥѴGέק
 * Ҧ{]p̤TФHOd :)
 ******************************************************************************/


#ifndef SCD_TABCTRL_CPP
#define SCD_TABCTRL_CPP

#include <wx/arrimpl.cpp>
#include <wx/notebook.h>
#include <wx/imaglist.h>
#include <wx/spinbutt.h>
// ----------------------------------------------------------------------------

class SCD_TabCtrl : public wxControl
{
public:
	~SCD_TabCtrl()
	{
		int c = GetItemCount();
		for(int i=c-1;i>=0;i--)
		{
			DeleteItem(i);
		}
	}

	void Init();
	
	void InsertItem(int item, const wxString& text, int imageId, void* clientData);
	bool DeleteItem(int index);
	bool DeleteItem(void *client_data);
	
	void ShowPreviousTab();
	void ShowNextTab();

	inline int GetSelection()	{	return now_selected_index;	}
	inline int GetItemCount()	{	return TabObjectList.Count();	}
	void* GetItemData(int index);
	int GetItemIndex(void* p);
	int GetItemImage(int item);

	int SetSelection(int index);
	wxString GetItemText(int item);
	bool SetItemText(int item, const wxString& text);
	bool SetItemImage(int item, int image);


	void SetImageList(wxImageList* list)	{	image_list = list;	}
	void SetPadding(const wxSize& p)
 	{
  		padding = p;
  		SetSize( GetClientSize().GetWidth(), GetCharHeight() + p.GetHeight() * 2 );
	}

	int getTabUnderMouse(int x, int y);	//oy (x,y) Us

private:

	typedef struct
	{
		wxString text;
		void *clientData;
		int imageId;
		
		//pG text  image ܰ, Y tab ~ܰʪ, h] true,
  		//åBjsp tab  width height
		bool outlook_changed;	
		int width;
		int height;
		
	} TabObject;

	wxPointerArray TabObjectList;
	int now_start_index, now_selected_index, now_right_index;
	wxImageList *image_list;
	wxSize padding;

	wxSpinButton spin;

	inline bool isTabVisible(int index);
	inline int isTabExist(int index)	{	return index >= 0 && index < GetItemCount();	}
	int DrawTab(int index , wxDC *dc , int start_x);
	void recalcTabSize(int index);
	void recalcTabSize(TabObject *tab);

	void OnResize(wxSizeEvent& event);
	void OnSpin(wxSpinEvent& event);
	
	void OnMouseLeftDown(wxMouseEvent& event);
	void OnMouseRightDown(wxMouseEvent& event);
	void OnPaint(wxPaintEvent& event);

    DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(SCD_TabCtrl, wxControl)
	EVT_LEFT_DOWN(SCD_TabCtrl::OnMouseLeftDown)
	EVT_RIGHT_DOWN(SCD_TabCtrl::OnMouseRightDown)
	EVT_PAINT(SCD_TabCtrl::OnPaint)
	
	EVT_SIZE(SCD_TabCtrl::OnResize)
	EVT_SPIN(666, SCD_TabCtrl::OnSpin)
END_EVENT_TABLE()
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_TabCtrl::Init()
{
	spin.Create(this, 666, wxDefaultPosition, wxDefaultSize, wxSP_HORIZONTAL);
	spin.SetRange(0,0);

	now_start_index = 0;
	now_selected_index = -1;
	now_right_index = 0;
	SetPadding( wxSize(9,5) );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_TabCtrl::InsertItem(int item, const wxString& text, int imageId = -1, void* clientData = NULL)
{
	TabObject *tab = new TabObject;
	tab->text = text;
	tab->imageId = imageId;
	tab->clientData = clientData;
	TabObjectList.Add(tab);
	recalcTabSize(tab);
	spin.SetRange(0, GetItemCount() - 1);

	Refresh();
}
// ----------------------------------------------------------------------------
bool SCD_TabCtrl::DeleteItem(int index)
{
	if( ! isTabExist(index) )	return false;

	TabObject *tab;
	tab = (TabObject*) ( TabObjectList.Item(index) );
	TabObjectList.RemoveAt(index);
	delete tab;

	if( GetItemCount() > 0 )
		spin.SetRange(0, GetItemCount() - 1);
	else
		spin.SetRange(0, 0);

	int old_index = GetSelection();

	if( old_index >= GetItemCount() )
		SetSelection( GetItemCount() - 1 );
	else if( old_index > index )
		SetSelection( old_index - 1 );
	else
		SetSelection( old_index );

	return true;
}
// ----------------------------------------------------------------------------
bool SCD_TabCtrl::DeleteItem(void *client_data)
{
	int i = TabObjectList.Index(client_data);
	if(i == wxNOT_FOUND)	return false;
	
	return DeleteItem(i);
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
int SCD_TabCtrl::SetSelection(int index)
{
	if( GetItemCount() <= 0 )
	{
		if( index == -1 );
		else return now_selected_index;
	}
	else if( ! isTabExist(index) )	return now_selected_index;
	

	if( index < now_start_index || index > now_right_index )
		now_start_index = index;

	int old_selected_index = now_selected_index;

	// EVT_TAB_SEL_CHANGING ƥ
	wxNotebookEvent eb(wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING , GetId() , index , old_selected_index );
	GetParent()->ProcessEvent(eb);

	//s
	now_selected_index = index;
	Refresh();

	// EVT_TAB_SEL_CHANGED ƥ
	wxNotebookEvent ea(wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED , GetId() , index , old_selected_index );
	GetParent()->ProcessEvent(ea);

	return old_selected_index;
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::ShowPreviousTab()
{
	if( GetItemCount() <= 1 )	return;
//	else if( GetSelection() >= GetItemCount() )	return;
	else if( GetSelection() <= 0 )	SetSelection( GetItemCount() - 1 );
	else	SetSelection( GetSelection() - 1 );
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::ShowNextTab()
{
	if( GetItemCount() <= 1 )	return;
	else if( GetSelection() >= GetItemCount() - 1 )	SetSelection(0);
	else	SetSelection( GetSelection() + 1 );
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void* SCD_TabCtrl::GetItemData(int index)
{
	if( ! isTabExist(index ) ) return NULL;
	return ((TabObject*) (TabObjectList.Item( index )))->clientData;
}
// ----------------------------------------------------------------------------
int SCD_TabCtrl::GetItemIndex(void* p)
{
	int i, c;
	c = GetItemCount();
	for(i=0;i<c;i++)
  		if( p == GetItemData(i) )	return i;

	return -1;
}
// ----------------------------------------------------------------------------
int SCD_TabCtrl::GetItemImage(int item)
{
	if( ! isTabExist(item) ) return -1;
	TabObject *tab = (TabObject*) (TabObjectList.Item(item));
	return tab->imageId;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
wxString SCD_TabCtrl::GetItemText(int item)
{
	if( ! isTabExist(item) ) return wxEmptyString;
	TabObject *tab = (TabObject*) (TabObjectList.Item(item));
	return tab->text;
}
// ----------------------------------------------------------------------------
bool SCD_TabCtrl::SetItemText(int item, const wxString& text)
{
	if( ! isTabExist(item) ) return false;
	TabObject *tab = (TabObject*) (TabObjectList.Item(item));
	tab->text = text;
	recalcTabSize(item);
	Refresh();
	return true;
}
// ----------------------------------------------------------------------------
bool SCD_TabCtrl::SetItemImage(int item, int image)
{
	if( ! isTabExist(item) ) return false;
	TabObject *tab = (TabObject*) (TabObjectList.Item(item));
	tab->imageId = image;
	recalcTabSize(item);
	Refresh();
	return true;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_TabCtrl::recalcTabSize(int index)
{
	if( ! isTabExist(index) )	return;
	recalcTabSize( (TabObject*)(TabObjectList.Item(index)) );
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::recalcTabSize(TabObject *tab)
{
	int _w = 0, _h = 0;
	int tmp_w, tmp_h;

	if( image_list && tab->imageId >= 0 )
	{
		image_list->GetSize( tab->imageId , tmp_w , tmp_h );
		_w = padding.GetWidth() + tmp_w;
		_h = tmp_h;
	}

	int text_width, text_height;
	wxClientDC dc(this);	//*** need to optimization ***//

	dc.GetTextExtent( wxString( _T("0. ") ) + tab->text , & text_width , & text_height );
	if( text_height > _h )	_h = text_height;
	_w += padding.GetWidth() + text_width;

	tab->width  = _w + padding.GetWidth();
	tab->height = _h + padding.GetHeight() * 2;
}
// ----------------------------------------------------------------------------
inline bool SCD_TabCtrl::isTabVisible(int index)
{
	if( ! isTabExist(index) )	return false;
	return true;
}
// ----------------------------------------------------------------------------
int SCD_TabCtrl::getTabUnderMouse(int x, int y)	//oy (x,y) Us
{
	int button_right = 0;
	for(int i=now_start_index ; isTabVisible(i) ; i++)
	{
		TabObject *tab = (TabObject*)(TabObjectList.Item(i));
		button_right += tab->width;
		if( x < button_right )	return i;
	}
	return -1;
}
// ----------------------------------------------------------------------------
int SCD_TabCtrl::DrawTab(int index , wxDC *dc , int start_x)
{
	if( ! isTabVisible(index) )	return start_x;

	TabObject *tab = (TabObject*)(TabObjectList.Item(index));
	
	//eWs
	if( index == now_selected_index )
 	{
	    dc->SetBrush( wxBrush( wxSystemSettings::GetColour(wxSYS_COLOUR_BTNHIGHLIGHT) , wxSOLID ) );
		dc->SetPen( wxPen( wxSystemSettings::GetColour(wxSYS_COLOUR_BTNSHADOW), 1, wxSOLID ) );
		dc->DrawRoundedRectangle( start_x + 1 , 1 , tab->width - 5 , GetClientSize().GetHeight() - 1, 8 );
	}
	
	int _x = start_x + padding.GetWidth(), _y = padding.GetHeight();

	//eW tab ϥ (pGw ImageList )
	if( image_list && tab->imageId >= 0 )
	{
		int img_w, img_h;
		image_list->GetSize( tab->imageId , img_w , img_h );
		image_list->Draw( tab->imageId, *dc, _x, _y, wxIMAGELIST_DRAW_TRANSPARENT, true);
		_x += img_w + 6;
	}

	//eWD
	dc->SetTextForeground(*wxBLACK);
	dc->DrawText( wxString::Format( _T("%d. ") , index + 1 ) + tab->text, _x , _y );
	
	int right = start_x + tab->width - 1;
	dc->SetPen( wxPen( wxSystemSettings::GetColour(wxSYS_COLOUR_BTNSHADOW), 1, wxSOLID ) );
	dc->DrawLine(right-1, 0, right-1, tab->height);
	dc->SetPen( wxPen( wxSystemSettings::GetColour(wxSYS_COLOUR_BTNHIGHLIGHT), 1, wxSOLID ) );
	dc->DrawLine(right, 0, right, tab->height);

	return right + 1;	//Ǧ^k
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
void SCD_TabCtrl::OnMouseLeftDown(wxMouseEvent& event)
{
	int m_x, m_y;
	m_x = event.GetX();
	m_y = event.GetY();

	int old_selection = GetSelection();
	int i = getTabUnderMouse( m_x , m_y );
	if( i >= 0 && i != old_selection )
		SetSelection(i);
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::OnMouseRightDown(wxMouseEvent& event)
{	GetParent()->AddPendingEvent(event);	}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::OnPaint(wxPaintEvent& event)
{
	wxPaintDC dc(this);
	dc.SetFont( GetFont() );


	int win_width, win_height;
	GetClientSize( & win_width, & win_height );
	win_height = 30;

	if( now_start_index >= GetItemCount() && GetItemCount() > 0 )
 		now_start_index = GetItemCount() - 1;

	dc.BeginDrawing();

	int start_x, i;
	for(start_x = 0 , i = now_start_index ; start_x < win_width && isTabExist(i) ;i++)
		start_x = DrawTab(i, &dc , start_x);

	dc.EndDrawing();

	if( start_x < win_width )	now_right_index = i + 1;
	else	now_right_index = i - 2;
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::OnResize(wxSizeEvent& event)
{
	spin.Move( GetClientSize().GetWidth() - spin.GetSize().GetWidth() , 0 );
}
// ----------------------------------------------------------------------------
void SCD_TabCtrl::OnSpin(wxSpinEvent& event)
{
	if( now_start_index != event.GetPosition() )
	{
		now_start_index = event.GetPosition();
		Refresh();
	}
}
// ----------------------------------------------------------------------------
#endif
